#!/usr/local/bin/perl

# mailonoff.pl {on|off} <list>

$on = shift;
$on =~ tr/A-Z/a-z/;
if ($on eq "on") {
  $on = 1;
} elsif ($on eq "off") {
  $on = 0;
} else {
  die 'parameter is not ot "on" or "off"';
}
$list = shift;
die 'missing list parameter' unless $list;

$realfrom = "";
$from = "";
$header = 1;
while (<>) {
  tr/\n\r//d;
  last if /^$/;
  if (/^From (\S+)\s/i) {
    $realfrom = $1;
  } elsif (/^From:\s*(.*)/) {
    $from = $1;
  }
}
while (<>) {
}
# close (OUT);

# print "'$realfrom'$from'\n";

if ($realfrom && $from) {
  if ($on) {
    $name = $from;
    if ($from =~ /\</) {
      $name =~ s/\<.*\>//;
    } elsif ($from =~/\(/) {
      $name =~ s/[^(]*\(//;
      $name =~ s/\)[^)]*//;
    }
    $name =~ s/^\s*//;
    $name =~ s/\s*$//;
    $command = "subscribe $list $name";
  } else {
    $command = "unsubscribe $list";
  }
  open(MAIL, "|/usr/lib/sendmail -t -f $realfrom") or die 'cant open sendmail';
  print MAIL <<EOM;
From: $from
To: listserv\@list.stairways.com
Subject: none

$command
EOM
  close(MAIL);
}
